Codeforces Round #423 Div. 2 C. String Reconstruction

C. String Reconstruction
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Ivan had string s consisting of small English letters. However, his friend Julia decided to make fun of him and hid the string s. Ivan preferred making a new string to finding the old one.

Ivan knows some information about the string s. Namely, he remembers, that string ti occurs in string s at least ki times or more, he also remembers exactly ki positions where the string ti occurs in string s: these positions are xi, 1, xi, 2, ..., xi, ki. He remembers n such strings ti.

You are to reconstruct lexicographically minimal string s such that it fits all the information Ivan remembers. Strings ti and string sconsist of small English letters only.

Input

The first line contains single integer n (1 ≤ n ≤ 105) — the number of strings Ivan remembers.

The next n lines contain information about the strings. The i-th of these lines contains non-empty string ti, then positive integer ki, which equal to the number of times the string ti occurs in string s, and then ki distinct positive integers xi, 1, xi, 2, ..., xi, ki in increasing order — positions, in which occurrences of the string ti in the string s start. It is guaranteed that the sum of lengths of strings ti doesn't exceed1061 ≤ xi, j ≤ 1061 ≤ ki ≤ 106, and the sum of all ki doesn't exceed 106. The strings ti can coincide.

It is guaranteed that the input data is not self-contradictory, and thus at least one answer always exists.

Output

Print lexicographically minimal string that fits all the information Ivan remembers.

Examples
input
3
a 4 1 3 5 7
ab 2 1 5
ca 1 4
output
abacaba
input
1
a 1 3
output
aaa
input
3
ab 1 1
aba 1 3
ab 2 3 5
output
ababab

这题好神啊

用了并查集的思想

因为不冲突

next[i]表示从i之后(包括i)还没被确定的最前位置

然后使用next[i]前先路径压缩一波

就能以nlogn的复杂度过这题了

Orz

#include<cstdio>
#include<cstring>
const int N=1e7+10;
char a[N],b[N];
int next[N]	;
int get(int x)
{
	return next[x]==x?x:next[x]=get(next[x]);
}
int main()
{
	int n;int max=0;
	scanf("%d",&n);	
	for(int i=1;i<=N;i++)	next[i]=i;
	for(int i=1;i<=n;i++)
	{
		scanf("%s",b+1);
		int k;int len=strlen(b+1);
		scanf("%d",&k);
		int x;
		for(int j=1;j<=k;j++)
		{
			scanf("%d",&x);
			int rr=get(x);
			for(int ss=rr;ss<=x+len-1;ss++)
			a[ss]=b[ss-x+1],next[ss]=len+x-1;
		}
		max=max>(len+x-1)?max:(len+x-1);
	}	
	for(int i=1;i<=max;i++)
	if(a[i]==0)	printf("%c",'a');
	else printf("%c",a[i]);
	return 0;
}

————————————————————分割线————————————————————

后来做另一道相似题codevs 1191 数轴染色 时发现应该是修改每一个位置时都get一下f[i]

而我之前的做法是只get起点的f[i],然后后面的都直接做了

于是我每个位置都并查集一下

但效率并没有提高

仍然用了300+ms

可能是数据的原因吧。。


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值